Skip to content

API Reference (2026-02-20)

Welcome to the v1 API reference for the Zuora Billing, Payments, and Platform!

To learn about the common use cases of the Zuora v1 API, check out the API Tutorials.

Important: This API Reference only showcases the parameters, fields, and behaviors available for the latest API minor version (2025-08-12). For more information about Zuora API versions, see API versions and API upgrades.

We recommend that you upgrade to the latest API version to take advantage of the latest Zuora capabilities. For instructions about upgrading the API version, see API upgrade guide.

Try the v1 API in our Postman collection:

Run In Postman

Some of our older APIs are no longer recommended but still available, not affecting any existing integration. To find related API documentation, see Older API Reference.

More OpenAPI specification options

To support your integration with our OpenAPI specifications, whether using in-house solutions or third-party tools, we provide the following resources:

If you need a different API specification beyond the options above, contact Zuora Global Support, and we will provide a custom spec tailored to your needs.

Download OpenAPI description
Overview
Languages
Servers
Mock server
https://developer.zuora.com/_mock/v1-api-reference/api
US Developer & Central Sandbox (incl. Test Drive)
https://rest.test.zuora.com
US API Sandbox Cloud 1
https://rest.sandbox.na.zuora.com
US API Sandbox Cloud 2
https://rest.apisandbox.zuora.com
US Production Cloud 1
https://rest.na.zuora.com
US Production Cloud 2
https://rest.zuora.com
EU Developer & Central Sandbox
https://rest.test.eu.zuora.com
EU API Sandbox
https://rest.sandbox.eu.zuora.com
EU Production
https://rest.eu.zuora.com
APAC Developer & Central Sandbox
https://rest.test.ap.zuora.com
APAC Production
https://rest.ap.zuora.com

OAuth

Zuora recommends that you use OAuth v2.0 to authenticate to the Zuora REST API.

You must first create an OAuth client in the Zuora UI before using the Create an OAuth token operation to create an OAuth token. See Authentication for more information.

Operations

Commerce

The Commerce APIs provide access to product catalog, plans, charges, and order management functionality in Zuora. These endpoints are used to create, update, and query product rate plans, charges, and dynamic pricing details that drive subscription and billing behavior.

In a typical use case, the Commerce APIs are called to provision new products or plans in the catalog, configure dimensional pricing, or submit orders that create and modify subscriptions.

Changes made with these APIs affect the product catalog and active subscriptions, depending on the endpoint. Catalog changes update future subscription behavior, while order operations directly impact customer subscriptions in real time.'

Operations

Accounts

Some operations in this section are similar to each other, but are provided for different use scenarios. You should choose the one that best suits your needs.

For example, the Retrieve an account operation retrieves the basic information of an account, such as bill-to and sold-to contacts, billing and payments setup information, and metrics data for the account.

The Retrieve an account summary operation returns the more detailed information of an account, such as bill-to and sold-to contacts, subscriptions, invoices, payments, and usages associated with this account.

Operations

Contacts

A contact defines the customer who holds an account or who is otherwise a person to contact about an account. An account requires a contact for the BillToId and SoldToId fields before the account can be active.

Operations

Contact Snapshots

Every time a contact is updated a snapshot is taken.

Operations

Sign Up

A light-weight API to sign up customers and subscribe.

You need to have the Orders or Orders Harmonization feature enabled to use this API.

Operations

Orders

Orders are contractual agreements between merchants and customers.

You can create multiple subscriptions and subscription amendments at once in a single order. All the operations on subscriptions in orders are done by order actions. You can also create order line items to support your non-subscription based business models.

Zuora calculates order delta metrics when orders take place. You can retrieve order delta metrics and measure billed and unbilled amounts by order.

For more information about Orders, see Overview Of Orders. To learn how orders interacts with billing accounts, subscriptions, and product catalog, see Zuora object model.

Operations

Preview an order

Request

Notes:

  • This operation is only available if you have the Orders feature enabled. If you are an existing Zuora Subscribe and Amend customer, we recommend you enable Orders Harmonization to access the Orders feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing.
  • The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
  • You cannot preview enhanced discounts and usage charges.
  • You can skip the accounting period validation to avoid backdated subscription cancellation caused order preview failure. To skip the accounting period validation, submit a request at Zuora Global Support.

Retrieves the preview of the charge metrics and invoice items of a specified order. Preview for subscriptions and order line items are both supported. This operation is only an order preview and no order is created.

You can also use this operation to preview billing for a standalone order. For more information, see Preview billing for a standalone order.

Billing preview behavior regarding draft invoices

By default, the billing preview behavior regarding draft invoices is as below:

  • When you preview billing for your order and the order contains subscriptions only, the draft invoices are excluded.
  • When you preview billing for your order and the order contains order line items only, the draft invoices are included.
  • When you preview billing for an order that contains both subscriptions order line items, the draft invoices are included for both subscriptions and order line items.

However, if you want to always exclude the draft invoices in billing preview, submit a request at Zuora Global Support.

Limits on Orders API

The limit of orders allowed on a subscription is 1000.

The limit of order line items allowed in an order is 100.

Zuora has the following limits on the Orders synchronous API to prevent performance degradation:

If you have an Order that exceeds any limits of the above, Zuora recommends you use the following asynchronous API operations:

Zuora has the following limits on the Orders asynchronous API operations to prevent performance degradation:

Security
bearerAuth
Query
summarizeInvoiceItemboolean

Indicates whether to return aggregated invoice item summaries for each invoice.

With this parameter set to true, the invoices > invoiceItemSummary field is returned in the preview result. The aggregated invoiceItemSummary field provides a forecast of the number of future invoices (previewInvoiceSequence), and the following information for each invoice:

  • subTotal
  • total
  • taxAmount
  • discountAmount
  • servicePeriodStartDate
  • servicePeriodEndDate
Default false
Headers
Idempotency-Keystring<= 255 characters

Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types.

With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.

Accept-Encodingstring

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-Encodingstring

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-Idsstring

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-Idsstring

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

Zuora-Versionstring

The minor API version.

For a list of available minor versions, see API upgrades.

Bodyapplication/jsonrequired
categorystring

Category of the order to indicate a product sale or return. Default value is NewSales.

Default "NewSales"
Enum"NewSales""Return"
customFieldsobject(OrderCustomFields)

Container for custom fields of an Order object.

descriptionstring<= 500 characters

A description of the order.

existingAccountIdstring

The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.

Note: You can specify either the existingAccountNumber or existingAccountId field, but not both.

existingAccountNumberstring<= 70 characters

The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.

Example: "A00000097"
orderDatestring(date)required

The date when the order is signed. All of the order actions under this order will use this order date as the contract effective date.

Example: "2024-07-01"
orderLineItemsArray of objects(OrderLineItem)

Order Line Items are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.

With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.

If you do not have the Create Order Line Items Without Product Catalog billing permission, you can only create order line items from existing products by specifying the product rate plan charge ID in the productRatePlanChargeId field. For more information about billing permissions, see Billing Roles.

Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.

orderNumberstring<= 100 characters

The order number of this order.
Note: The characters #, ?, and / are not allowed in this field. Additionally, to ensure compatibility with the UI when viewing orders, use only the following special characters: _,-, ., ~, *, (, ), and '.

previewAccountInfoobject(previewAccountInfo)

Information about the account that will own the order.

previewOptionsobject(PreviewOptions)required
previewOptions.​previewNumberOfPeriodsintegernon-empty

The number of periods to preview when the value of the previewThroughType field is set to NumberOfPeriods.

previewOptions.​previewThruTypestring

The options on how the preview through date is calculated. Available for preview only.

  • If you set this field to SpecificDate, you must specify a specific date in the specificPreviewThruDate field. If you also set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than specificPreviewThruDate are returned.

  • If you set this field to NumberOfPeriods, you must use the previewNumberOfPeriods field to specify how many periods you want to preview. In case the order only contains an order line item but not contains a subscription, if you also set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than today are returned.

  • The TermEnd option is invalid when any subscription included in this order is evergreen. In case the order only contains an order line item but not contains a subscription, if you set this field to TermEnd and set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than today are returned.

Enum"SpecificDate""TermEnd""NumberOfPeriods"
previewOptions.​previewTypesArray of strings

One or more types of the preview. It can include:

  • ChargeMetrics: charge level metrics will be returned in the response, including: cmrr, tcv, tcb, and tax.
  • BillingDocs: invoices and creditMemos will be returned in the response. Note creditMemos is only available if the Invoice Settlement feature is enabled.
  • OrderDeltaMetrics: order delta metrics will be returned in the response, including: orderDeltaMrr, orderDeltaTcb and orderDeltaTcv.
  • OrderMetrics: order metrics will be returned in the response, including: quantity, mrr, tcb, tcv, and elp. Note: As of Zuora Billing Release 306, Zuora has upgraded the methodologies for calculating metrics in Orders. The new methodologies are reflected in the OrderDeltaMetrics. It is recommended that all customers use the Order Delta Metrics. If you are an existing Order Metrics customer and want to migrate to Order Delta Metrics, submit a request at Zuora Global Support. Whereas new customers, and existing customers not currently on Order Metrics, will no longer have access to Order Metrics, existing customers currently using Order Metrics will continue to be supported.
  • RampMetrics: ramp metrics will be returned in the response, including: quantity, mrr, tcb, tcv metrics for each charge and each ramp interval.
  • RampDeltaMetrics: ramp metrics changes will be returned in the response, including: deltaQuantity, deltaMrr, deltaTcb, deltaTcv metrics for each charge and each ramp interval.
Items Enum"ChargeMetrics""BillingDocs""OrderDeltaMetrics""OrderMetrics""RampMetrics""RampDeltaMetrics"
previewOptions.​skipTaxboolean

If set to true, the system will bypass the tax calculation during order preview.

Default false
previewOptions.​specificPreviewThruDatestring(date)

The end date of the order preview. You can preview the invoice charges through the preview through date. (Invoice preview only)

Note: This field is only applicable if the 'previewThruType' field is set to 'SpecificDate'.

previewOptions.​chargeTypeToExcludeArray of strings

The charge types to exclude from the forecast run.

Items Enum"OneTime""Recurring""Usage"
reasonCodestring<= 255 characters

Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs.

subscriptionsArray of objects

Each item includes a set of order actions, which will be applied to the same base subscription. When you create an order that involves multiple subscriptions, these subscriptions can have different invoice owner accounts or subscription owner accounts.

Example: [{"orderActions":[{"type":"CreateSubscription","createSubscription":{"terms":{"initialTerm":{"period":12,"periodType":"Month","termType":"TERMED"},"renewalSetting":"RENEW_WITH_SPECIFIC_TERM","renewalTerms":{"period":12,"periodType":"Month"}},"subscribeToRatePlans":[{"productRatePlanId":"8ad081dd9096ef9501909b40bb4e74a4"}]},"triggerDates":[{"name":"ContractEffective","triggerDate":"2024-07-01"},{"name":"ServiceActivation","triggerDate":"2024-07-01"},{"name":"CustomerAcceptance","triggerDate":"2024-07-01"}]}]}]
curl -i -X POST \
  'https://developer.zuora.com/_mock/v1-api-reference/api/v1/orders/preview?summarizeInvoiceItem=false' \
  -H 'Accept-Encoding: string' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Encoding: string' \
  -H 'Content-Type: application/json' \
  -H 'Idempotency-Key: string' \
  -H 'Zuora-Entity-Ids: string' \
  -H 'Zuora-Org-Ids: string' \
  -H 'Zuora-Track-Id: string' \
  -H 'Zuora-Version: string' \
  -d '{
    "existingAccountNumber": "A00000097",
    "orderDate": "2024-07-01",
    "previewOptions": {
      "previewTypes": [
        "BillingDocs"
      ],
      "previewThruType": "SpecificDate",
      "specificPreviewThruDate": "2024-07-31"
    },
    "subscriptions": [
      {
        "orderActions": [
          {
            "type": "CreateSubscription",
            "createSubscription": {
              "terms": {
                "initialTerm": {
                  "period": 12,
                  "periodType": "Month",
                  "termType": "TERMED"
                },
                "renewalSetting": "RENEW_WITH_SPECIFIC_TERM",
                "renewalTerms": {
                  "period": 12,
                  "periodType": "Month"
                }
              },
              "subscribeToRatePlans": [
                {
                  "productRatePlanId": "8ad081dd9096ef9501909b40bb4e74a4"
                }
              ]
            },
            "triggerDates": [
              {
                "name": "ContractEffective",
                "triggerDate": "2024-07-01"
              },
              {
                "name": "ServiceActivation",
                "triggerDate": "2024-07-01"
              },
              {
                "name": "CustomerAcceptance",
                "triggerDate": "2024-07-01"
              }
            ]
          }
        ]
      }
    ]
  }'

Responses

OK

Headers
Content-Encodingstring

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-Limitstring

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingnumber

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetnumber

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-Idstring= 36 characters

The Zuora internal identifier of the API call. You cannot control the value of this header.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Concurrency-Limit-Typestring

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Bodyapplication/json
processIdstring

The ID of the process that handles the operation.

reasonsArray of objects

The container of the error code and message. This field is available only if the success field is false.

requestIdstring(uuid)= 36 characters

Unique identifier of the request.

successboolean

Indicates whether the call succeeded.

previewResultobject(PreviewOrderResult)

The result of each type of preview. Returned only when the current request is preview call.

Response
application/json
{ "success": true, "previewResult": { "invoices": [ … ] } }

Preview an order asynchronously

Request

Notes:

  • This operation is only available if you have the Orders feature enabled. Orders is now generally available as of Zuora Billing Release 284 (August 2020). If you are an existing Zuora Subscribe and Amend customer, we recommend you enable Orders Harmonization to access the Orders feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing.
  • The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
  • You cannot preview enhanced discounts and usage charges.

In the case where a normal "Preview an order" operation call will time out, use this operation instead to preview an order asynchronously. A job will be previewing the order in the back end; the job ID will be returned for tracking the job status and result.

Billing preview behavior regarding draft invoices

By default, the billing preview behavior regarding draft invoices is as below:

  • When you preview billing for your order and the order contains subscriptions only, the draft invoices are excluded.
  • When you preview billing for your order and the order contains order line items only, the draft invoices are included.
  • When you preview billing for an order that contains both subscriptions order line items, the draft invoices are included for both subscriptions and order line items.

However, if you want to always exclude the draft invoices in billing preview, submit a request at Zuora Global Support.

Limits on Orders API

The limit of orders allowed on a subscription is 1000.

The limit of order line items allowed in an order is 100.

Zuora has the following limits on the Orders synchronous API to prevent performance degradation:

If you have an Order that exceeds any limits of the above, Zuora recommends you use the following asynchronous API operations:

Zuora has the following limits on the Orders asynchronous API operations to prevent performance degradation:

Security
bearerAuth
Query
summarizeInvoiceItemboolean

Indicates whether to return aggregated invoice item summaries for each invoice.

With this parameter set to true, the invoices > invoiceItemSummary field is returned in the preview result. The aggregated invoiceItemSummary field provides a forecast of the number of future invoices (previewInvoiceSequence), and the following information for each invoice:

  • subTotal
  • total
  • taxAmount
  • discountAmount
  • servicePeriodStartDate
  • servicePeriodEndDate
Default false
Headers
Idempotency-Keystring<= 255 characters

Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types.

With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.

Accept-Encodingstring

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-Encodingstring

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-Idsstring

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-Idsstring

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

Zuora-Versionstring

The minor API version.

For a list of available minor versions, see API upgrades.

Bodyapplication/jsonrequired
categorystring

Category of the order to indicate a product sale or return. Default value is NewSales.

Default "NewSales"
Enum"NewSales""Return"
customFieldsobject(OrderCustomFields)

Container for custom fields of an Order object.

descriptionstring<= 500 characters

A description of the order.

existingAccountIdstring

The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.

Note: You can specify either the existingAccountNumber or existingAccountId field, but not both.

existingAccountNumberstring<= 70 characters

The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.

Example: "A00000097"
orderDatestring(date)required

The date when the order is signed. All of the order actions under this order will use this order date as the contract effective date.

Example: "2024-07-01"
orderLineItemsArray of objects(OrderLineItem)

Order Line Items are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.

With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.

If you do not have the Create Order Line Items Without Product Catalog billing permission, you can only create order line items from existing products by specifying the product rate plan charge ID in the productRatePlanChargeId field. For more information about billing permissions, see Billing Roles.

Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.

orderNumberstring<= 100 characters

The order number of this order.
Note: The characters #, ?, and / are not allowed in this field. Additionally, to ensure compatibility with the UI when viewing orders, use only the following special characters: _,-, ., ~, *, (, ), and '.

previewAccountInfoobject(previewAccountInfo)

Information about the account that will own the order.

previewOptionsobject(PreviewOptions)required
previewOptions.​previewNumberOfPeriodsintegernon-empty

The number of periods to preview when the value of the previewThroughType field is set to NumberOfPeriods.

previewOptions.​previewThruTypestring

The options on how the preview through date is calculated. Available for preview only.

  • If you set this field to SpecificDate, you must specify a specific date in the specificPreviewThruDate field. If you also set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than specificPreviewThruDate are returned.

  • If you set this field to NumberOfPeriods, you must use the previewNumberOfPeriods field to specify how many periods you want to preview. In case the order only contains an order line item but not contains a subscription, if you also set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than today are returned.

  • The TermEnd option is invalid when any subscription included in this order is evergreen. In case the order only contains an order line item but not contains a subscription, if you set this field to TermEnd and set billTargetDate in the orderLineItems field, order line items whose billTargetDate is no later than today are returned.

Enum"SpecificDate""TermEnd""NumberOfPeriods"
previewOptions.​previewTypesArray of strings

One or more types of the preview. It can include:

  • ChargeMetrics: charge level metrics will be returned in the response, including: cmrr, tcv, tcb, and tax.
  • BillingDocs: invoices and creditMemos will be returned in the response. Note creditMemos is only available if the Invoice Settlement feature is enabled.
  • OrderDeltaMetrics: order delta metrics will be returned in the response, including: orderDeltaMrr, orderDeltaTcb and orderDeltaTcv.
  • OrderMetrics: order metrics will be returned in the response, including: quantity, mrr, tcb, tcv, and elp. Note: As of Zuora Billing Release 306, Zuora has upgraded the methodologies for calculating metrics in Orders. The new methodologies are reflected in the OrderDeltaMetrics. It is recommended that all customers use the Order Delta Metrics. If you are an existing Order Metrics customer and want to migrate to Order Delta Metrics, submit a request at Zuora Global Support. Whereas new customers, and existing customers not currently on Order Metrics, will no longer have access to Order Metrics, existing customers currently using Order Metrics will continue to be supported.
  • RampMetrics: ramp metrics will be returned in the response, including: quantity, mrr, tcb, tcv metrics for each charge and each ramp interval.
  • RampDeltaMetrics: ramp metrics changes will be returned in the response, including: deltaQuantity, deltaMrr, deltaTcb, deltaTcv metrics for each charge and each ramp interval.
Items Enum"ChargeMetrics""BillingDocs""OrderDeltaMetrics""OrderMetrics""RampMetrics""RampDeltaMetrics"
previewOptions.​skipTaxboolean

If set to true, the system will bypass the tax calculation during order preview.

Default false
previewOptions.​specificPreviewThruDatestring(date)

The end date of the order preview. You can preview the invoice charges through the preview through date. (Invoice preview only)

Note: This field is only applicable if the 'previewThruType' field is set to 'SpecificDate'.

previewOptions.​chargeTypeToExcludeArray of strings

The charge types to exclude from the forecast run.

Items Enum"OneTime""Recurring""Usage"
reasonCodestring<= 255 characters

Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs.

subscriptionsArray of objects

Each item includes a set of order actions, which will be applied to the same base subscription. When you create an order that involves multiple subscriptions, these subscriptions can have different invoice owner accounts or subscription owner accounts.

Example: [{"orderActions":[{"type":"CreateSubscription","createSubscription":{"terms":{"initialTerm":{"period":12,"periodType":"Month","termType":"TERMED"},"renewalSetting":"RENEW_WITH_SPECIFIC_TERM","renewalTerms":[{"period":12,"periodType":"Month"}]},"subscribeToRatePlans":[{"productRatePlanId":"8ad081dd9096ef9501909b40bb4e74a4"}]},"triggerDates":[{"name":"ContractEffective","triggerDate":"2024-07-01"},{"name":"ServiceActivation","triggerDate":"2024-07-01"},{"name":"CustomerAcceptance","triggerDate":"2024-07-01"}]}]}]
curl -i -X POST \
  'https://developer.zuora.com/_mock/v1-api-reference/api/v1/async/orders/preview?summarizeInvoiceItem=false' \
  -H 'Accept-Encoding: string' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Encoding: string' \
  -H 'Content-Type: application/json' \
  -H 'Idempotency-Key: string' \
  -H 'Zuora-Entity-Ids: string' \
  -H 'Zuora-Org-Ids: string' \
  -H 'Zuora-Track-Id: string' \
  -H 'Zuora-Version: string' \
  -d '{
    "existingAccountNumber": "A00000097",
    "orderDate": "2024-07-01",
    "previewOptions": {
      "previewTypes": [
        "BillingDocs"
      ],
      "previewThruType": "SpecificDate",
      "specificPreviewThruDate": "2024-07-31"
    },
    "subscriptions": [
      {
        "orderActions": [
          {
            "type": "CreateSubscription",
            "createSubscription": {
              "terms": {
                "initialTerm": {
                  "period": 12,
                  "periodType": "Month",
                  "termType": "TERMED"
                },
                "renewalSetting": "RENEW_WITH_SPECIFIC_TERM",
                "renewalTerms": [
                  {
                    "period": 12,
                    "periodType": "Month"
                  }
                ]
              },
              "subscribeToRatePlans": [
                {
                  "productRatePlanId": "8ad081dd9096ef9501909b40bb4e74a4"
                }
              ]
            },
            "triggerDates": [
              {
                "name": "ContractEffective",
                "triggerDate": "2024-07-01"
              },
              {
                "name": "ServiceActivation",
                "triggerDate": "2024-07-01"
              },
              {
                "name": "CustomerAcceptance",
                "triggerDate": "2024-07-01"
              }
            ]
          }
        ]
      }
    ]
  }'

Responses

Accepted

Headers
Content-Encodingstring

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
Locationstring

URL for accessing the job result, in the format of /async-jobs/{jobId}. For example, /async-jobs/2c90a02d676688200167770ce20601b6

RateLimit-Limitstring

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingnumber

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetnumber

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-Idstring= 36 characters

The Zuora internal identifier of the API call. You cannot control the value of this header.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Concurrency-Limit-Typestring

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Bodyapplication/json
jobIdstring(UUID)

The ID of an asynchronous job that will be returned for tracking the status and result of the job.

Response
application/json
{ "jobId": "2c90a02d676688200167770ce20601b6" }

List orders

Request

Note: This feature is only available if you have the Order Metrics feature enabled. As of Zuora Billing Release 284, Orders is generally available and the Order Metrics feature is no longer available as a standalone feature. If you are an existing Subscribe and Amend customer and want Order Metrics only, you must turn on Orders Harmonization. You can still keep the existing Subscribe and Amend API integrations to create and manage subscriptions.

Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.

Retrieves information about all orders in your tenant. You can set the status query parameter to an order status to retrieve orders in that order status. If you do not set a value for this query parameter, the query parameter has a default value all, and orders of all statuses are returned. By default, it returns the first page of the orders.

Security
bearerAuth
Query
pageinteger>= 1

The index number of the page that you want to retrieve. This parameter is dependent on pageSize. You must set pageSize before specifying page. For example, if you set pageSize to 20 and page to 2, the 21st to 40th records are returned in the response.

Default 1
pageSizeinteger<= 40

The number of records returned per page in the response.

Default 20
dateFilterOptionstring

The date type to filter on. This field value can be orderDate or updatedDate. Default is orderDate.

startDatestring(date)

The result will only contain the orders with the date of dateFilterOption later than or equal to this date.

endDatestring(date)

The result will only contains orders with the date of dateFilterOption earlier than or equal to this date.

statusstring

The status of orders.

Enum"all""cancelled""completed""draft""executing""failed""pending""scheduled"
Headers
Accept-Encodingstring

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-Encodingstring

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-Idsstring

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-Idsstring

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

Zuora-Versionstring

The minor API version.

For a list of available minor versions, see API upgrades.

curl -i -X GET \
  'https://developer.zuora.com/_mock/v1-api-reference/api/v1/orders?page=1&pageSize=20&dateFilterOption=string&startDate=2019-08-24&endDate=2019-08-24&status=all' \
  -H 'Accept-Encoding: string' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Encoding: string' \
  -H 'Zuora-Entity-Ids: string' \
  -H 'Zuora-Org-Ids: string' \
  -H 'Zuora-Track-Id: string' \
  -H 'Zuora-Version: string'

Responses

OK

Headers
Content-Encodingstring

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-Limitstring

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingnumber

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetnumber

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-Idstring= 36 characters

The Zuora internal identifier of the API call. You cannot control the value of this header.

Zuora-Track-Idstring<= 64 characters

A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Concurrency-Limit-Typestring

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Bodyapplication/json
nextPagestring(URL)

URL to retrieve the next page of the response if it exists; otherwise absent.

ordersArray of objects(Order)
successboolean

Indicates whether the call succeeded.

Response
application/json
{ "orders": [ { … }, { … } ] }

Order Actions

You need to have the Orders or Orders Harmonization feature enabled to use this API.

Operations

Order Line Items

Use order line item to launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models. For more information about order line items, see Order Line Items.

Operations

Fulfillments

Fulfillments are subordinate objects attached to their related order line item. Fulfillment items are subordinate objects attached to their related fulfillment.

For more information, see Overview of Order Line Items.

Operations

Ramps

A Ramp is a time container to associate with rate plan charges in your subscription. Inside the Ramp, you can further define a set of Ramp Intervals (time-based periods) where products or pricing can change. These periods are sub time containers to enable you to report out-of-the-box metrics based on Ramp Intervals.

Notes: You must have both the Ramps feature and Orders feature enabled for your tenant to use the Ramps operations.

For more information, see Ramps and Ramp Metrics.

Operations

Subscriptions

A subscription is a product or service that has recurring charges, such as a monthly flat fee or charges based on usage. Subscriptions can also include one-time charges, such as activation fees. Every subscription must be associated with an account. At least one active account must exist before any subscriptions can be created.

For more information, see Subscriptions.

Operations

Omnichannel Subscriptions

An omnichannel subscription is a subscription originating from external and source systems, such as the Apple App Store, Google Play Store, and Roku Store.

To create, update, delete, or retrieve an omnichannel subscription, you must turn on the Omni-Channel Subscription feature. For more information, see Omni-Channel Subscription.

Operations

Subscription Change History

The change histories of single version subscriptions.

Note: To access the change histories, you must turn on the following features:

Operations

Rate Plans

A rate plan is part of a subscription or an amendment to a subscription, and it comes from a product rate plan. Like a product and its product rate plans, a subscription can have one or more rate plans. Rate plans are sometimes called subscription rate plans. Rate plans that are part of an amendment are sometimes called amendment rate plans.

Rate plans represent a price or a collection of prices for a service you sell. An individual rate plan contains all charges specific to a particular subscription.

Operations

Commitments

A commitment represents a minimum or maximum spend amount a customer is obligated to pay within a spend period, compared with customer's actual fees incurred in connection with customer's accounts and their use of applicable products. The Commitments API allows you to retrieve details of the commitments a customer has.

Operations

Prepaid with Drawdown

The Prepaid with Drawdown feature is a pricing model for consumption-based services, such as data storage. Under this model, customers pay upfront to receive a number of units, usually for a period of time like a month or a year. Then they consume against that prepayment balance in a use-it-or-lose-it fashion, with a possibility of topping up more units or being charged for any overage. This model strikes a balance between upfront commitment and the pure pay-as-you-go pricing models. For more information, see Prepaid with Drawdown.

Operations

Usage

Consumption of a billable service or resource (such as database storage space or bundles of emails sent) provides the basis for some charge models - simple usage, tiered pricing, or volume pricing. To make this work, usage must be tracked in the system and usage charges must be calculated and invoiced. Usage is always billed in arrears - for example, you might bill customers in February for their January usage. Usage can be billed on a recurring monthly, quarterly, semi-annual, or annual basis.

Operations

Meters

The Zuora Mediation APIs provide a comprehensive set of endpoints to manage, test, run, and monitor usage meters. These APIs support actions such as running or testing specific meter versions, importing and exporting meter configurations, managing input files, performing event store operations, and ingesting usage data in real time via streaming. All APIs follow a consistent response structure to simplify integration and error handling. Use these APIs to automate and streamline your usage processing pipeline—from data ingestion to transformation and billing.

Operations

Delivery Adjustments

Delivery Adjustments are used to handle end customer delivery complaints for the Delivery Pricing charge model. For more information, see Delivery Adjustments.

Operations

Billing Documents

Billing documents include invoices, credit memos, and debit memos.

Note: Credit memos and debit memos are only available if you have the Invoice Settlement feature enabled.

Operations

Invoices

Invoices provides information about customers' accounts for invoices, for examples, dates, status, and amounts.

For more information about invoices, see Invoice.

Operations

Credit Memos

Credit memos reduce invoice and account balances. By applying one or more credit memos to invoices with positive balances, you can reduce the invoice balances in the same way that applying a payment to an invoice.

For more information about credit memos, see Credit and debit memos.

Operations

Debit Memos

Debit memos increase the amount a customer owes. It is a separate document from the invoice. Debit memos can be used to correct undercharging on an invoice or to levy ad hoc charges outside the context of a subscription. Just like an invoice, debit memo balances can be settled by applying either a payment or a credit memo.

For more information about debit memos, see Credit and debit memos.

Operations

E-Invoicing

With the E-Invoicing feature, Zuora supports electronic invoices through an integration with partners that have a local presence, where required, which guarantees compliance with local invoice regulations.

All the operations in this section are available only if you have the E-Invoicing feature enabled.

Operations

Invoice Schedules

Use invoice schedules to trigger invoice generation processes.

For more information about invoice schedules, see Billing Schedule overview.

Operations

Taxation Items

The TaxationItem object is used to add a tax amount to an invoice item. In the typical use case, the tax amount that you specify in the object is calculated by Z-Tax or a third-party tax engine such as Avalara or Connect tax engine.

Changes that you make with this object affect the product charges in your product catalog, but not the charges in existing subscriptions.

Operations

Sequence Sets

You can create billing document sequence sets through the REST API or the Zuora UI, allowing distinct numbering sequences for billing documents, payments, and refunds.

To create a billing document sequence set through the Zuora UI, see Create Billing Document Sequence Sets for more information.

Operations

Operations

Use operations to generate invoices and credit memos, collect payments for posted invoices, and generate previews of future invoice items for customer accounts.

Operations

Summary Statements

The Summary Statement feature provides a comprehensive overview of billing activities for each account using HTML templates that compile data like invoices, credit memos, payments, and more. The associated APIs help automate the creation and management of these statements. See Account Summary Statements for more information.

Operations

Bill Run

Use the Bill Run call to create ad hoc bill runs and Post, Cancel, Query, and Delete bill runs.

For more information about bill runs, see Bill runs.

Operations

Billing Preview Run

A billing preview run asynchronously generates a downloadable CSV file containing a preview of future invoice item data and credit memo item data for a batch of customer accounts.

Note: Credit memo item data is only available if you have the Invoice Settlement feature enabled.

Operations

Payment Methods

Payment methods represents payment method details associated with a customer account.

Operations

Custom Payment Method Types

Open Payment Method (OPM) service is a framework developed by Zuora, which allows you to integrate your custom payment method to Zuora subscription, billing, and revenue management in a dynamic and flexible manner. With the support of the OPM service, you are able to define your custom payment method types and create custom payment methods of the defined types. The custom payment method of the defined type can only be used with the custom payment gateway that you set up through the Universal Payment Connector (UPC) service. It cannot be used with the Zuora out-of-box gateway integrations such as GoCardless, Stripe, etc.

You can define up to 20 custom payment method types for one tenant. Do not define your fields with the Zuora-reserved fields.

See Set up custom payment gateways and payment methods for more information about the OPM and UPC services.

Note: You can only use the bearer token to access the "Custom Payment Method Types" API operations. Access with apiAccessKeyId and apiSecretAccessKey is not supported.

Operations

Payment Method Updater

Zuora Payment Method Updater (PMU) enables merchants to automatically incorporate changes made to a customer's credit cards. For more information about Zuora PMU, see Payment Method Updater.

Operations

Payment Method Snapshots

A Payment Method Snapshot is a copy of the particular Payment Method used in a transaction. If the Payment Method is deleted, the Snapshot continues to retain the data used in each of the past transactions. As such, the Snapshot helps with display of historical transactions, integrations to external systems, and reporting.

Operations

Payment Method Transaction Logs

The PaymentMethodTransactionLog object contains payment method transaction log data.

You can use the CRUD: Retrieve a payment method transaction log operation to export such data.

Operations

Hosted Pages

Hosted payment pages allow your customers to set up a payment method, such as providing a credit card. Since it only handles the payment method, it is suitable for a simple workflow or a complex multi-page, multi-product workflow.

For more information, see Hosted Payment Pages.

Operations

RSA Signatures

The REST API used in Payment Pages 2.0 are CORS (Cross-Origin Resource Sharing) enabled and therefore requires a digital signature.

You can use the Generate an RSA signature operation to generate the required digital signature and token for a Payment Pages 2.0 form, then use the Decrypt an RSA signature operation to decrypt the signature to validate the signature and key."

Operations

Payment Authorization

The Delayed Capture feature allows you to authorize the availability of funds for a transaction but delay the capture of funds until a later time.

You can use the Create authorization operation to authorize a payment amount before capturing the payment. Subsequently, you can use Create a payment or Create an order to capture the authorized funds, or use Cancel authorization to cancel the authorization.

Operations

Payment Gateways

Use payment gateways to pass authorization, payments, and settlement data securely to and from the merchant's website to the merchant's processor.

For more information about payment gateways, see Payment Gateways.

Operations

Payment Gateway Reconciliation

Gateway reconciliation is the process of verifying that the electronic payment and refund transactions processed in Zuora match the transactions reported by the gateway. For example, if Zuora processed 200 transactions through a gateway, you should see the same number of transactions on the gateway's reconciliation report, sometimes also called the settlement report.

You can complete the following Gateway Reconciliation tasks through API:

Operations

Payments

Use payments to process payments, for example, automate recurring payments, manage overpayments, and create refunds. For more information about payments, see Payments.

Operations

Payment Transaction Logs

Use payment transaction logs to export logs of all transactions from Zuora to the Gateway for Payments.

Operations

Payment Runs

Use payment runs to collect payments using electronic payment methods, for example, credit cards and ACH. For more information about payment runs, see Payment Runs.

Operations

Payment Schedules

Use payment schedules to split invoice or account balances into several installments and automatically process payments for the installments. For more information about payment schedules, see Payment Schedules.

Operations

Refunds

Zuora allows you to issue and track refunds on payments. Similar to external payments, users can enter external refunds to track refunds that have been performed outside of Zuora Payments (for example, by issuing a check). In addition, you can make electronic refunds using our supported payment gateways, which will automatically refund money to the customer.

Operations

Payment Profiles

Payment profiles enable payment flexibility for subscribers by allowing payment methods to be associated with specific subscriptions.

To learn more about the configuration and usage of Payment Profiles, see Payment Profiles.

Operations

Configurable Payment Retry

Configurable Payment Retry APIs use basic authentication. The user name is the email address that you use for logging in Zuora. The password is the API token that is shown in the settings of Configurable Payment Retry. Click the drop-down arrow at the end of an endpoint to display the full endpoint. To learn more about the configuration and usage of Configurable Payment Retry, see Configurable Payment Retry.

Operations

Object Queries

The Object Query API contains GET operations that allow you to query objects in your Zuora tenant in an efficient, consistent, and flexible manner.

With the expand[] and filter[] query parameters, you have the flexibility to retrieve related object information in a single call and define the returned response that best suits your needs. You can also use the fields[] query parameter to define which fields are returned in the response for a given object. The sort[] query parameter allows you to sort the results in ascending or descending order based on the specified field.

These parameters are case-insensitive matching.

For general Object Queries limitations and comprehensive introduction to these query parameters, see Expand, filter, fields, and sort.

For filterable, expandable, and sortable fields on each object, refer to the Query Parameters section for each API operation.

Operations

Accounting Codes

Accounting Codes are commonly referred to as General Ledger Accounts or General Ledger Account Codes. In Zuora, the use of accounting codes are optional but recommended.

This section contains the operations that allow you to create, update, get, delete, activate, or deactivate accounting codes in Zuora.

Operations

Accounting Periods

A key step in configuring Finance is to create accounting periods in Zuora to match your company's financial calendar. This allows Zuora to produce reports and data exports organized by accounting periods, and to perform the work of closing the accounting periods for the revenue sub-ledger.

Operations

Summary Journal Entries

A summary journal entry is a summary of Zuora transaction amounts organized by accounting code and general ledger segments. A segment adds more reporting granularity through business dimensions, such as country or product.

For more information, see Summary Journal Entries Introduction

Operations

Journal Runs

Use journal runs to automatically create summary journal entities that are suitable for importing into your general ledger system.

For more information about journal runs, see Journal Runs.

Operations

Mass Updater

Use mass updater to perform mass actions more easily.

For more information about mass updater, see Mass Updater.

Operations

Notifications

Notifications are the actions taken to inform users or call third-party endpoints when a certain event happens. Typical actions include emails and callouts. Callouts typically refer to HTTP invocations, such as HTTP calls to REST services.

Zuora notification system processes the events in the same order in which they are triggered. The timing and delivery of notifications can still vary based on factors such as retries, concurrency, and network latency. But Zuora guarantees the best performance possible with the right performance boosters and tuning.

Notifications are associated with Communication Profiles, which allow you to send specific event-driven notifications to targeted customers. Zuora provides the following Settings API to access the settings of Communication Profiles:* Get all Communication Profiles

Operations

Custom Event Triggers

The Event Trigger service manages the business events and trigger conditions that are defined on Zuora Business Object Model or custom objects. When a Zuora object changes, the trigger conditions defined on the object are evaluated, and if any condition qualifies, a business event will be triggered and turned into a notification.

Note: Event Triggers operations are only applicable to custom events.

Operations

Custom Scheduled Events

A custom scheduled event notification is evaluated at the scheduled time of the related scheduled event on a daily basis. If the date meets the combination of the base field and the notification parameters, the notification will be triggered immediately.

For more information about Custom Scheduled Events, see Custom Scheduled Events.

Operations

Custom Object Definitions

With Custom Objects service, you can define custom objects, extending the Zuora data model to accommodate your specific use cases.

If you use Postman, you can import the custom objects endpoints as a collection into your Postman app and try out different requests to learn how the API works.

You can sign up for a free account on the Postman website and download the app in case you do not use Postman yet.

Note that the Custom Object Definitions API is versioned by Zuora-Version in the request header. The response may be different for the same request with a different API version. Specify Zuora-Version in the request header if you expect a specific response schema.

Operations

Custom Object Records

With Custom Objects service, you can create, update, delete and find custom object records.

If you use Postman, you can import the custom objects endpoints as a collection into your Postman app and try out different requests to learn how the API works.

You can sign up for a free account on the Postman website and download the app in case you do not use Postman yet.

Note that the Custom Object Records API is versioned by Zuora-Version in the request header. The response may be different for the same request with a different API version. Specify Zuora-Version in the request header if you expect a specific response schema.

Operations

Custom Object Jobs

With Custom Objects service, you can submit a bulk job request to create, update, or delete custom object records in a batch.

If you use Postman, you can import the custom objects endpoints as a collection into your Postman app and try out different requests to learn how the API works.

You can sign up for a free account on the Postman website and download the app in case you do not use Postman yet.

Note that the Custom Object Jobs API is versioned by Zuora-Version in the request header. The response may be different for the same request with a different API version. Specify Zuora-Version in the request header if you expect a specific response schema.

Operations

API Health

Zuora System Health dashboard for API (API dashboard) collects and displays data about API usage, failure, performance, and concurrency limit in near real time. It enables you to view all the APIs in your Zuora tenant within the last 14 days. For more information, see APIs dashboard.

Operations

Bill Run Health

Zuora System Health dashboard for Bill Run (Bill Run dashboard) collects and displays data about bill run usage, failure, and performance in near real time. Through the Bill Run dashboard, you can view data about all the bill runs in your Zuora tenant within the last 30 days. For more information, see Bill Run dashboard.

Operations

Electronic Payments Health

Zuora System Health dashboard for Electronic Payments (Electronic Payment dashboard) collects and displays usage, failure, and performance data about electronic payments in near real time. It enables you to view all the electronic payments in your Zuora tenant within the last 30 days. For more information, see Electronic Payments dashboard.

Operations

Tax Health

Zuora System Health dashboard for Tax Health (Tax Health dashboard) collects and displays usage, failure, and performance data about Tax in near real time. It enables you to view all the tax details in your Zuora tenant within the last 30 days. For more information, see Tax Health Dashboard.

Operations

Workflows

A workflow is a sequence of tasks that are performed based on predefined logic. A workflow improves efficiency and reduces errors by automating a series of complex tasks that otherwise need to be performed manually and repetitively.

For more information, see Workflow.

Operations

Data Queries

The Data Query feature enables you to perform SQL queries in your Zuora tenant. To learn how to get started with Data Query, see Overview of Data Query.

Operations

Aggregate Queries

The Aggregate Query API (AQuA) is a REST API that executes multiple Export ZOQL or ZOQL queries. The queries are performed in a sequential order and in a single read-only database transaction.

AQuA enforces the following limits:

  • The maximum processing time per query is 3 hours. If a query in an AQuA job is executed for longer than 3 hours, this job will be killed automatically. See the best practices for bulk data extraction with AQuA.

  • AQuA enforces limits on both the stateful concurrent AQuA jobs and the stateless concurrent AQuA jobs per tenant:

    • The maximum number of stateful concurrent AQuA jobs per tenant is 50. - The maximum number of stateless concurrent AQuA jobs per tenant is 50. AQuA jobs in the following status are counted towards your concurrent AQuA job limits:
    • Submitted - Executing Zuora system will reject the subsequent stateful or stateless job requests once the corresponding concurrent job limit is reached.

For more information about the Aggregate Query API(AQuA), see Aggregate Query.

Operations

Configuration Templates

Configuration Templates in Zuora Deployment Manager enable you to configure your tenants in minutes by importing a templated metadata configuration file. This feature eliminates the need for long manual configuration processes that would have previously taken hours. You will be able to access a comprehensive repository of industry-specific templates. It will be easier for you to deploy and release. To use this API for migrating metadata from a source tenant to a destination tenant, you should authenticate using credentials of the source tenant The user will have to provide the client id and secret key from the sou.rce tenant. To understand the known behavior of configuration templates and APIs, see the following sections: Product Catalog deployment known facts and system behavior Product Catalog deployment FAQs Deployment Manager Known Facts and Limitations

Operations

Metadata

The Metadata API in Zuora promotes a programmatic way to retrieve, compare, and validate metadata within Zuora tenants for performing create and update actions between the source and the target. To use this API for migrating metadata from a source tenant to a destination tenant, you should authenticate using credentials of the source tenant. The user will have to provide the client id and secret key from the source tenant. To understand the known behavior of configuration templates and APIs, see the following sections: Product Catalog deployment known facts and system behavior Product Catalog deployment FAQs Deployment Manager Known Facts and Limitations

Operations

Bulk Data

The Bulk Data API operations allow you to manage bulk data loader services and perform programmatic CRUD (Create, Update, Read/export, Delete) operations.
To perform data ingestion with a CSV file in Zuora Billing using the Data Loader Bulk Data APIs, see Tutorial for Bulk job API with CSV. For more information, see Process Bulk Job with JSON-lines in Data Loader.

Operations

SCIM

System for Cross-domain Identity Management, or SCIM, is an API specification created to facilitate the management of people and groups of people in cloud-based applications and services. Universal Identity SCIM API is built on top of the SCIM 2.0 specification and can be integrated with major Identity Providers like Okta, Microsoft Entra ID and OneLogin.

Zuora recommends that you use OAuth v2.0 to authenticate to the Zuora REST API.

You must first create an OAuth client in the Zuora UI before using the Create an OAuth token operation to create an OAuth token. See Authentication for more information.

Operations

Data Labeling

The Data Labeling APIs help you to label your existing data with organization(s) in Zuora.

Once you turned on Multi Org feature, if you don't label your existing data, they are simply unlabeled, and unlabeled data can be accessed by all organizations in your tenant.

To limit the access of your existing data, you need to label them with organization(s) you defined in the organization hierarchy management setting page. Once labeled, the data can only be accessed by users who have been granted with the labeled organization(s).

Note that you have to enable the "Multi Org" feature before using the Data Labeling APIs.

Operations

Data Backfill

If you are an Order to Revenue user, you can use the data backfill operations to perform, view or stop data backfill tasks.

Operations

Regenerate

If you are an Order to Revenue user, you can use the Regenerate operations to regenerate transactions objects.

Operations

Test Environments

A Test Environment is a dedicated sandbox tenant designed for development, integration, and user acceptance testing of your system configurations and business processes.

Operations

Test Environment Jobs

A Test Environment Job represents an asynchronous operation initiated to refresh a Test Environment. These jobs track the status and progress of environment provisioning and refresh.

Operations

Test Environment Notifications

A Test Environment Notification is an automated email dispatched to inform stakeholders when a Test Environment Job is completed or cancelled.

Operations

Actions

Actions are operations that are batch in nature. For example, the "create", "update", "delete", and other operations allow changes to up-to 50 objects at a time. The "query" operation will return up-to 2000 result records back at a time, before requiring additional pages of data to be returned via a subsequent "queryMore" operation.

The default WSDL version for Actions is 79. If you want to change the WSDL version, set the X-Zuora-WSDL-Version header. To find out in which WSDL version a particular object or field was introduced, see Zuora SOAP API Version History.

Note: Actions do not support the Invoice Settlement feature. This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. Actions also do not support the Orders feature.

Operations

Settings

The Setting API provides a central API for managing settings in your Zuora tenant.

If you use Postman, you can import the Settings API endpoints as a collection into your Postman app and try out different requests to learn how the API works. You can sign up for a free account on the Postman website and download the app in case you do not use Postman yet.

Operations

Files

You can use the operations contained in this section to retrieve files such as export results, invoices, accounting period reports, and so on.

Operations

Imports

An import uploads content, especially when you have a large amount of content. The Import object contains all of the information you need to upload content, such as a large number of usage records.

Operations

Custom Exchange Rates

If you use a custom exchange rate provider and upload rates with the Import Foreign Exchange Rates mass action, you can query custom foreign exchange rates from Zuora through API.

This feature is in Limited Availability. If you wish to have access to the feature, submit a request at Zuora Global Support.

Operations

Attachments

Use attachments in Zuora to upload documents of various formats to associate additional information with accounts, subscriptions, invoices, credit memos, or debit memos. Example attachments could be purchase orders (PO's), tax exemption document, or ownership transfer forms.

For more information about attachments, see Attachments.

Operations

Describe

You can use the Describe an object operation to get a reference listing of each object that is available in your Zuora tenant.

By default, the information returned by the "Describe an object" operation corresponds to the latest version of the Zuora WSDL.

Operations

Products

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

A product is an item or service that your company sells. In the subscription economy, a product is generally a service that your customers subscribe to rather than a physical item that they purchase one time. For example, customers subscribe to a service that provides them a car when and where they need a car rather than buying a car outright.

A Product object contains all of the items in a specific product, especially product rate plans and product rate plan charges. Each Product object can have multiple rate plans, which in turn can each have multiple rate plan charges. Each rate plan charge can have multiple tiers. Taken together, all of these items create a single product.

Customers subscribe to products that are in your product catalog. Product objects collectively compose your product catalog. You create your product catalog by creating products. As soon as you create your first product, you create your product catalog.

Operations

Catalog

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

The Zuora Billing product catalog is where you define your products and pricing. The product catalog's ability to handle sophisticated pricing models gives you the power to easily adapt your pricing to customer and market needs, to grow your business and drive more revenue.

Operations

Catalog Groups

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

A catalog group is used to group a list of product rate plans with a specific grade.

Operations

Product Rate Plans

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

A product rate plan is the part of a product that your customers subscribe to. Each product can have multiple product rate plans, and each product rate plan can have multiple product rate plan charges, which are fees for products and their product rate plans.

Operations

Product Rate Plan Definitions

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

Use product rate plan definitions to reuse charges in different product rate plans. The Product Rate Plan Definition object is in the Early Adopter phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you are interested, please reach out to your CSM.

Operations

Product Rate Plan Charges

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

A product rate plan charge represents a charge model or a set of fees associated with a product rate plan, which is the part of a product that your customers subscribe to. Each product rate plan can have multiple product rate plan charges.

Product rate plan charges can be of three types: one-time fees, recurring fees, and usage fees. For example, the $50 activation fee for the Topaz product rate plan is a one-time product rate plan charge.

Operations

Product Charge Definitions

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

Use product charge definitions to define the attributes that can determine the charge behavior, such as billing attributes, pricing attributes, taxation attributes, or accounting attributes.\n\nThe Product Charge Definition object is in the Early Adopter phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you are interested, please reach out to your CSM.

Operations

Product Rate Plan Charge Tiers

Note - The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

To manage product rate plan charge tiers, use the Product Rate Plan Charges operations instead to update the corresponding product rate plan charge with all the tiers.

Operations

Zuora Revenue Integration

Note: You can only use the operations in this section if you have the Billing - Revenue Integration feature enabled. See Billing - Revenue Integration for more information. The APIs in this section are legacy APIs. Zuora recommends using the newer, faster APIs for managing products and catalogs more efficiently instead. For more information, see our latest Commerce API.

Operations